﻿using System;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;

namespace cs37_webio_binary
{
    public partial class Form1 : Form
    {
        
        Socket TCP_Client;

        byte[] receiveBuffer = new byte[512];
        byte[] lastReceive = new byte[512];

        private delegate void DelegateSub();

        
        public Form1()
        {
            InitializeComponent();
        }
        //--------------------------------------------------------------------------------------------


        private void Form1_FormClosing(object sender, FormClosingEventArgs e) 
        {

            closeConnection();

        }
        //--------------------------------------------------------------------------------------------


        private void Form1_Load(object sender, EventArgs e)
        {

            this.gb_io.Enabled = false;
            this.bt_disconnect.Enabled = false;
            this.sb_status.Text = "no connection";

        }
        //--------------------------------------------------------------------------------------------


        private void bt_connect_Click(object As , EventArgs e )
        {

            if (this.ed_ip.Text != "" && this.ed_Port.Text != "")
            {
                try
                {

                    IPEndPoint ClientEP = new IPEndPoint(IPAddress.Parse(this.ed_ip.Text), int.Parse(this.ed_Port.Text));
                    TCP_Client = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

                    TCP_Client.BeginConnect(ClientEP, new AsyncCallback(callback_connect), TCP_Client);

                }
                catch (Exception)
                {
                    closeConnection();
                    this.sb_status.Text = "Error while connecting!";
                }
            }else{
                this.sb_status.Text = "IP and Port needed!";
            }

        }
        //--------------------------------------------------------------------------------------------


        private void callback_connect(IAsyncResult ar)
        {       

            try
            {

                TCP_Client.EndConnect(ar);

                this.sb_status.Text = "connected";

                this.Invoke(new DelegateSub(disconnectenable));
                TCP_Client.BeginReceive(receiveBuffer, 0, 512, SocketFlags.None, new AsyncCallback(callback_receive), TCP_Client);

            }
            catch (Exception)
            {
                closeConnection();
                this.sb_status.Text = "Error while connecting!";
            }

        }
        //--------------------------------------------------------------------------------------------


        private void callback_receive(IAsyncResult ar)
        {

            int receiveCount = 0;

            try
            {
                if(TCP_Client != null)
                {
                    if (TCP_Client.Connected)
                    {
                        receiveCount = TCP_Client.EndReceive(ar);
                        Array.Copy(receiveBuffer, this.lastReceive, 511);
                        Array.Clear(receiveBuffer, 0, 512);
                        this.Invoke(new DelegateSub(evaluateResponse));
                        TCP_Client.BeginReceive(receiveBuffer, 0, 512, SocketFlags.None, new AsyncCallback(callback_receive), TCP_Client);
                    }
                }
            }
            catch (Exception)
            {
                this.sb_status.Text = "Error while receiving!";
            }

            if (receiveCount == 0)
            {
                closeConnection();
            }

        }
        //--------------------------------------------------------------------------------------------


        private void closeConnection()
        {

            try
            {
                if (TCP_Client != null)
                {
                    if (TCP_Client.Connected)
                    {
                        TCP_Client.Shutdown(SocketShutdown.Both);
                        TCP_Client.Close();
                        TCP_Client = null;
                    }   
                }

                this.sb_status.Text = "no connection";

                this.Invoke(new DelegateSub(connectenable));
            }
            catch (Exception)
            {
                this.sb_status.Text = "Error while disconnecting!";
            }

        }
        //--------------------------------------------------------------------------------------------


        private void disconnectenable()
        {

            this.bt_disconnect.Enabled = true;
            this.bt_connect.Enabled = false;
            this.gb_io.Enabled = true;

        }
        //--------------------------------------------------------------------------------------------


        private void connectenable()
        {

            this.bt_disconnect.Enabled = false;
            this.bt_connect.Enabled = true;
            this.gb_io.Enabled = false;

        }
        //--------------------------------------------------------------------------------------------


        private void evaluateResponse()
        {

            try
            {

                switch(lastReceive[4])
                {
                    case 8:
                        structs.WriteRegister WriteRegister = (structs.WriteRegister)ByteConvert.ToStruct(lastReceive, typeof (structs.WriteRegister));
                        for(int port = 0; port<12; port++)
                        {
                            if ((WriteRegister.Value & (UInt16)Math.Pow(2, port)) == Math.Pow(2, port))
                            {
                                ((CheckBox)this.Controls.Find("cb_input" + port, true)[0]).Checked = true;
                            }else{
                                ((CheckBox)this.Controls.Find("cb_input" + port, true)[0]).Checked = false;
                            }
                        }
                        break;

                    case 0x31:
                        structs.registerState RegisterState = (structs.registerState)ByteConvert.ToStruct(lastReceive, typeof(structs.registerState));
                        for(int port = 0; port<12; port++)
                        {
                            if ((RegisterState.InputValue & (UInt16)Math.Pow(2, port)) == Math.Pow(2, port))
                            {
                                ((CheckBox)this.Controls.Find("cb_input" + port, true)[0]).Checked = true;
                            }else{
                                ((CheckBox)this.Controls.Find("cb_input" + port, true)[0]).Checked = false;
                            }
                        }
                        for(int port = 0; port<12; port++)
                        {
                            if ((RegisterState.OutputValue & (UInt16)Math.Pow(2, port)) == Math.Pow(2, port))
                            {
                                ((CheckBox)this.Controls.Find("cb_output" + port, true)[0]).Checked = true;
                            }else{
                                ((CheckBox)this.Controls.Find("cb_output" + port, true)[0]).Checked = false;
                            }
                        }
                        break;

                    case 0xB4:
                        structs.Counter Counter = (structs.Counter)ByteConvert.ToStruct(lastReceive, typeof(structs.Counter));
                        ((TextBox)this.Controls.Find("ed_counter" + Counter.CounterIndex, true)[0]).Text = Counter.CounterValue.ToString();
                        break;

                    case 0xB5:

                        //Workaround!>>

                        byte[] tempArray = new byte[511];
                        Array.Copy(lastReceive, 0, tempArray, 0, 10);
                        Array.Copy(lastReceive, 9, tempArray, 11, 100);
                        Array.Copy(tempArray, lastReceive, 511);
                        //<<Workaround!

                        structs.AllCounter AllCounter = (structs.AllCounter)ByteConvert.ToStruct(lastReceive, typeof(structs.AllCounter));
                        for(int CounterIndex = 0; CounterIndex<12; CounterIndex++)
                        {
                            ((TextBox)this.Controls.Find("ed_counter" + CounterIndex, true)[0]).Text = AllCounter.CounterValues[CounterIndex].ToString();
                        }
                        break;

                }
            }
            catch (Exception)
            {
                this.sb_status.Text = "Error while receiving";
            }

        }
        //--------------------------------------------------------------------------------------------


        private void ed_interval_TextChanged(object sender, EventArgs e)
        {

            this.Timer_polling.Interval = int.Parse(this.ed_interval.Text);

        }
        //--------------------------------------------------------------------------------------------


        private void cb_output_Click(object sender, EventArgs e)
        {

            CheckBox Cur_cb = (CheckBox)sender;
            int CurOutputNo;

            if (Cur_cb.Name.Length == 10)
            {
                CurOutputNo = int.Parse(Cur_cb.Name.Substring(9, 1));
            }else{
                CurOutputNo = int.Parse(Cur_cb.Name.Substring(9, 2));
            }

            structs.setBit cmd = new structs.setBit();
            cmd.Start_1 = 0;
            cmd.Start_2 = 0;
            cmd.StructType = 0x9;
            cmd.StructLength = 12;
            cmd.Mask =  (UInt16)Math.Pow(2, CurOutputNo);

            if (Cur_cb.Checked)
            {
                cmd.Value = (UInt16)Math.Pow(2, CurOutputNo);
            }else{
                cmd.Value = 0;
            }

            byte[] sendCmd = ByteConvert.ToBytes(cmd, typeof(structs.setBit));
            TCP_Client.Send(sendCmd, sendCmd.Length, SocketFlags.None);

        }
        //--------------------------------------------------------------------------------------------


        private void bt_outputs_read_Click(object sender, EventArgs e)
        {

            structs.RegisterRequest readCmd = new structs.RegisterRequest();
            readCmd.Start_1 = 0;
            readCmd.Start_2 = 0;
            readCmd.StructType = 0x21;
            readCmd.StructLength = 8;

            byte[] sendCmd = ByteConvert.ToBytes(readCmd, typeof(structs.RegisterRequest));
            TCP_Client.Send(sendCmd, sendCmd.Length, SocketFlags.None);

        }
        //--------------------------------------------------------------------------------------------


        private void bt_inputs_read_Click(object sender, EventArgs e )
        {

            structs.RegisterRequest readCmd = new structs.RegisterRequest();
            readCmd.Start_1 = 0;
            readCmd.Start_2 = 0;
            readCmd.StructType = 1;
            readCmd.StructLength = 8;

            byte[] sendCmd = ByteConvert.ToBytes(readCmd, typeof(structs.RegisterRequest));
            TCP_Client.Send(sendCmd, sendCmd.Length, SocketFlags.None);

        }
        //--------------------------------------------------------------------------------------------


        private void bt_counter_readall_Click(object sender, EventArgs e)
        {

            structs.ReadAllCounter Cmd = new structs.ReadAllCounter();
            Cmd.Start_1 = 0;
            Cmd.Start_2 = 0;
            Cmd.StructType = 0xB1;
            Cmd.StructLength = 8;

            byte[] sendCmd = ByteConvert.ToBytes(Cmd, typeof(structs.ReadAllCounter));
            TCP_Client.Send(sendCmd, sendCmd.Length, SocketFlags.None);

        }
        //--------------------------------------------------------------------------------------------


        private void bt_counter_clearall_Click(object sender, EventArgs e)
        {

            structs.RegisterRequest Cmd = new structs.RegisterRequest();
            Cmd.Start_1 = 0;
            Cmd.Start_2 = 0;
            Cmd.StructType = 0xC1;
            Cmd.StructLength = 8;

            byte[] sendCmd = ByteConvert.ToBytes(Cmd, typeof(structs.RegisterRequest));
            TCP_Client.Send(sendCmd, sendCmd.Length, SocketFlags.None);

        }
        //--------------------------------------------------------------------------------------------


        private void bt_counter_read_Click(object sender, EventArgs e)
        {

            Button Cur_bt = (Button)sender;
            UInt16 CurCounterNo;

            if (Cur_bt.Name.Length == 16)
            {
                CurCounterNo = UInt16.Parse(Cur_bt.Name.Substring(15, 1));
            }else{
                CurCounterNo = UInt16.Parse(Cur_bt.Name.Substring(15, 2));
            }

            structs.readCounter readCmd = new structs.readCounter();
            readCmd.Start_1 = 0;
            readCmd.Start_2 = 0;
            readCmd.StructType = 0xB0;
            readCmd.StructLength = 10;
            readCmd.CounterIndex = CurCounterNo;

            byte[] sendCmd = ByteConvert.ToBytes(readCmd, typeof(structs.readCounter));
            TCP_Client.Send(sendCmd, sendCmd.Length, SocketFlags.None);

        }
        //--------------------------------------------------------------------------------------------


        private void bt_counter_clear_Click(object sender, EventArgs e)
        {

            Button Cur_bt = (Button)sender;
            UInt16 CurCounterNo;

            if (Cur_bt.Name.Length == 17)
            {
                CurCounterNo = UInt16.Parse(Cur_bt.Name.Substring(16, 1));
            }else{
                CurCounterNo = UInt16.Parse(Cur_bt.Name.Substring(16, 2));
            }

            structs.readClearCounter Cmd = new structs.readClearCounter();
            Cmd.Start_1 = 0;
            Cmd.Start_2 = 0;
            Cmd.StructType = 0xC0;
            Cmd.StructLength = 10;
            Cmd.CounterIndex = CurCounterNo;

            byte[] sendCmd = ByteConvert.ToBytes(Cmd, typeof(structs.readClearCounter));
            TCP_Client.Send(sendCmd, sendCmd.Length, SocketFlags.None);

        }
        //--------------------------------------------------------------------------------------------


        private void bt_disconnect_Click(object sender, EventArgs e)
        {

            closeConnection();

        }
        //--------------------------------------------------------------------------------------------


        private void Timer_polling_Tick(object sender, EventArgs e)
        {

            if (TCP_Client != null)
            {
                if (TCP_Client.Connected)
                {
                    if (cb_output_polling.Checked)
                    {
                        this.bt_outputs_read_Click(this, null);
                    }
                    if (cb_input_polling.Checked)
                    {
                        this.bt_inputs_read_Click(this, null);
                    }
                    if (cb_counter_polling.Checked)
                    {
                        this.bt_counter_readall_Click(this, null);
                    }
                }
            }

        }
    }
}
